#ifndef MUDB_H
#define MUDB_H

#include <sys/types.h>
#include <Message.h>
#include <Resources.h>
#include <limits.h>

void InitDB(bool read_only = true, const char *path = "/boot/home/config/etc/users");

uid_t UidForName(const char *uname);
const char *NameForUid(uid_t uid);

/*-----Delete pointers--------*/
BMessage *DBEntry(const char *uname);
BMessage *DBEntry(uid_t uid);
/*----------------------------*/

bool HasEntry(const char *uname);
bool HasEntry(uid_t uid);

void SetDBEntry(BMessage *to_set, uid_t uid = UINT_MAX, const char *uname = NULL);

char *encrypt_pwd(char *password);

extern int status;

#endif