#include <unistd.h>
#include <stdio.h>
#include <File.h>
#include <Message.h>
#include <Resources.h>
#include <netdb.h>
#include <string.h>
#include <OS.h>
#include <stdlib.h>
#include <image.h>
#include <termios.h>
#include <pwd.h>
#include "db.h"

int main(void) {
	bool logged_in = false;
	char login[255];
	char password[255];
	char prompt[255];
	char result[255];
	BMessage *user;
	gethostname(prompt,255);
	int attempts = 0;
	{
		InitDB();
		if (status == -1) {
			printf("You don't seem to have a users file. Make one, then come back.\n");
			return -1;
		}
		if (status == -2) {
			printf("Your users file is not valid. Please create a new one using adduser->\n");
			return -1;
		}
	}
	while ((!logged_in) && (attempts < 3)) {
		//-------Set echo off
		struct termios tio, saved_tio;
		printf("%s login: ",prompt);
		scanf("%s",login);
		printf("Password: ");
		
		fcntl( fileno(stdin), F_SETFL, 0 );
		tcgetattr(fileno(stdin), &tio);
		saved_tio = tio;
		tio.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHONL);
  		tcsetattr(fileno(stdin), TCSANOW, &tio);
  		
  		//----Get passwd------
  		scanf("%s",password);
  		
  		//----Turn echo on
  		tcsetattr(fileno(stdin), TCSANOW, &saved_tio);
  		
  		//fcntl( fileno(tty), F_SETFL, O_NONBLOCK );
  		
		
		password[254] = 0;
		
		user = DBEntry(login);
		
		if (user == NULL) {
		incorrect_password:
			printf("\nPassword incorrect. Wait a second...\n");
			snooze((int64)2e6);
			attempts++;
			continue;
		} else {
			if (strcmp(encrypt_pwd(password),user->FindString("password")) == 0) {
				logged_in = true;
				break;
			} else {
				goto incorrect_password;
			}
		}
		attempts++;
		continue;
	}
	if (logged_in) {
		setuid(UidForName(login));
		
		int64 id;
		gid_t gid = (user->FindInt64("gid",&id) == B_OK) ? id : 0;
		setgid(gid);
		
		sprintf(prompt,"USER=%s",login);
		putenv(prompt);
		
		sprintf(prompt,"HOME=%s",user->HasString("home") ? user->FindString("home") : "/boot/home");
		putenv(prompt);
		
		const char *argv[3] = {NULL,"-login",NULL};
		if (user->FindString("shell",&(argv[0])) != B_OK)
			argv[0] = "/bin/sh";
		int32 res;
		wait_for_thread(load_image(2,argv,(const char **)environ),&res);
		return 0;
	}
	printf("Too many failed logins. Goodbye!\n");
	return -1;
}